Imports System.IO

Partial Class Create_read_delete_text_file
    Inherits System.Web.UI.Page

    Protected Sub btnReadFile_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnReadFile.Click

        ' This code gets the filename in the "LocalFileUpload" textbox when the user has clicked the
        ' "btnReadFile" button and saves this file to the "tempfiles" folder on the webserver with 
        ' the same name as the original filename if the file has a ".txt" extension. Note that you need to have 
        ' the "files" folder to be able to save the file. This code then reads the text from the text file and
        ' outputs the text to a label. The text file on the webserver is finally deleted, the text file is only
        ' stored temporary on the webserver.

        Try
            If Not LocalFileUpload.PostedFile Is Nothing Then

                ' Gets the extension for the uploaded file
                Dim Extension As String = Path.GetExtension(LocalFileUpload.PostedFile.FileName)

                ' Check to see if the extension is ".txt"
                If Extension.ToLower() = ".txt" Then

                    ' Gets the filename of the posted file
                    Dim FileName As String = Path.GetFileName(LocalFileUpload.PostedFile.FileName)

                    ' Saves the file temporary on the webserver in the "tempfiles" folder
                    LocalFileUpload.PostedFile.SaveAs(Server.MapPath("tempfiles/") & FileName)

                    ' Read the text file from the webserver and outputs the result in a label, the Using 
                    ' block is used to call dispose (close) automatically even if there are an exception.
                    Using Reader As StreamReader = File.OpenText(Server.MapPath("tempfiles/" & FileName))
                        Dim Content As String = Reader.ReadToEnd()
                        lblReadText.Text = Content.Replace(vbCrLf, "<br>")
                    End Using

                    ' Deletes the text file that is saved in the "tempfiles" folder
                    File.Delete(Server.MapPath("tempfiles/" & FileName))

                Else
                    Message.Text = "The supplied file is not a textfile with the .txt extension."
                End If

            Else
                Throw New Exception()
            End If
        Catch ex As Exception
            Message.Text = "The file could not be read, the errormessage is: " & ex.ToString()
        End Try

    End Sub
End Class
