using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.IO;

public partial class Read_from_local_file : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }
    protected void btnReadFile_Click(object sender, EventArgs e)
    {
        // This code gets the filename in the "LocalFileUpload" textbox when the user has clicked the
        // "btnReadFile" button and saves this file to the "tempfiles" folder on the webserver with 
        // the same name as the original filename if the file has a ".txt" extension. Note that you need to have 
        // the "tempfiles" folder to be able to save the file. This code then reads the text from the text file and
        // outputs the text to a label. The text file on the webserver is finally deleted, the text file is only
        // stored temporary on the webserver.

        // The Try/Catch/Finally statement is used to handle exceptions.
        try
        {

            if (LocalFileUpload.PostedFile != null)
            {
                // Gets the extension for the uploaded file
                string Extension = Path.GetExtension(LocalFileUpload.PostedFile.FileName);

                // Check to see if the extension is ".txt"

                if (Extension.ToLower() == ".txt")
                {
                    // Gets the file name of the posted file
                    string FileName = Path.GetFileName(LocalFileUpload.PostedFile.FileName);

                    // Saves the file temporary on the webserver in the "tempfiles" folder
                    LocalFileUpload.PostedFile.SaveAs(Server.MapPath("tempfiles/") + FileName);

                    // Read the text file from the webserver and outputs the result in a label, the using 
                    // block is used to call dispose (close) automatically even if there are an exception.
                    using (StreamReader Reader = File.OpenText(Server.MapPath("tempfiles/" + FileName)))
                    {
                        string Content = Reader.ReadToEnd();
                        lblReadText.Text = Content.Replace("\r\n", "<br>");
                    }

                    // Deletes the text file that is saved in the "tempfiles" folder
                    File.Delete(Server.MapPath("tempfiles/" + FileName));

                }
                else
                {
                    Message.Text = "The supplied file is not a textfile with the .txt extension.";
                }

            }
            else
            {
                throw new Exception();
            }
        }
        catch (Exception ex)
        {
            Message.Text = "The file could not be read, the errormessage is: " + ex.ToString();
        }
    }
}
